﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace Train
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class FormTrain : Window
    {
        private DataForGUI dateForGUI;
        public FormTrain()
        {
            InitializeComponent();
        }
        private Data daten;
        private int index = 0;
        public void ShowFormAndInput(Data Daten, DataForGUI GUIDate)
        {
            daten = Daten;
            Top = 20;
            dateForGUI = GUIDate;
            if (GUIDate.NumberOfWindows == 1)
            {
                Left = 20;
            }
            else
            {
                Left = 450;
            }
            ShowData(index);
            Show();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }

        private void ShowData(int Index)
        {
            textBoxAdresse.Text = daten.TrainData[Index].Adress.ToString();
            labelDescription.Content = daten.TrainData[Index].Description;
            try
            {
                string dir = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetModules()[0].FullyQualifiedName) + "\\icons\\";
                string fileName = daten.TrainData[Index].IconFileName;
                string pfad = dir + fileName;
                image.Source = BitmapFrame.Create(new Uri(pfad));
            }
            catch
            {
            }
            labelSpeed.Content = daten.TrainData[Index].Speed.ToString();
            if (daten.TrainData[Index].Ligth == true)
            {
                toggleButtonLight.IsChecked = true;
            }
            else
            {
                toggleButtonLight.IsChecked = false;
            }
            //checkBoxDirection.Checked = daten.TrainData[Index].Direction;
            //if (checkBoxDirection.Checked == true)
            //{
            //    checkBoxDirection.Text = "<<";
            //}
            //else
            //{
            //    checkBoxDirection.Text = ">>";
            //}

        }

        private void button9_Click(object sender, RoutedEventArgs e)
        {
            index++;
            if (index > daten.TrainData.Count - 1) index = 0;
            ShowData(index);
        }

        private void button10_Click(object sender, RoutedEventArgs e)
        {
            index--;
            if (index < 0) index = daten.TrainData.Count - 1;
            ShowData(index);
        }

        private void toggleButtonLight_Checked(object sender, RoutedEventArgs e)
        {
              }

        private void toggleButtonLight_Unchecked(object sender, RoutedEventArgs e)
        {
          
        }

        private void toggleButtonLight_Click(object sender, RoutedEventArgs e)
        {
            if (toggleButtonLight.IsChecked == true) 
                daten.TrainData[index].Ligth = true;
            else
                daten.TrainData[index].Ligth = false;
            CommunicationToInterface.LigthOnTrain(daten.TrainData[index].Adress, daten.TrainData[index].Ligth);
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            // aktuelle Lok stoppen
            daten.TrainData[index].Speed = 0;
            labelSpeed.Content = daten.TrainData[index].Speed.ToString();
            CommunicationToInterface.TrainStop(daten.TrainData[index].Adress);
        }

        private void button6_Click(object sender, RoutedEventArgs e)
        {
            int delta = Int16.Parse(((Button)sender).Tag.ToString());
            daten.TrainData[index].Speed = daten.TrainData[index].Speed + delta;
            if (daten.TrainData[index].Speed < 0) daten.TrainData[index].Speed = 0;
            if (daten.TrainData[index].Speed > 28) daten.TrainData[index].Speed = 28;
            labelSpeed.Content = daten.TrainData[index].Speed.ToString();
            CommunicationToInterface.TrainSpeed(daten.TrainData[index].Adress, daten.TrainData[index].Speed, (bool) toggleButtonDirection.IsChecked);
        }

        private void toggleButtonDirection_Click(object sender, RoutedEventArgs e)
        {
            if (toggleButtonDirection.IsChecked == true)
                daten.TrainData[index].Direction = true;
            else
                daten.TrainData[index].Direction = false;
            // Geschwindigkeit auf "0" setzen
            daten.TrainData[index].Speed = 0;
            labelSpeed.Content = daten.TrainData[index].Speed.ToString();
            CommunicationToInterface.TrainSpeed(daten.TrainData[index].Adress, daten.TrainData[index].Speed, (bool) toggleButtonDirection.IsChecked);
        }

        private void Window_Closed(object sender, EventArgs e)
        {
            dateForGUI.NumberOfWindows--;
        }
    }
}
